<?php

/*********************************************************************

 Cron Like Ver 1.00 (2013/08/10)

*********************************************************************/

/********* ライセンス ************************************************

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 @Link http://www.php-labo.net/
 @Copyright(C) 2007-2013 PHP Labo
 @Author Knight <info at php-labo dot net>

*********************************************************************/

/********* 設定項目 *************************************************/

//リクエスト送信先(コンマ区切りで複数指定可能)
define('REQUEST_URL', 'http://www.example.com/example.php');

//リクエスト送信時間間隔
define('REQUEST_INTERVAL', 10 * 60);

//ログファイル名
define('LOG_FILE', 'request.log');

//ログ最大記録件数
define('LOG_LIMIT', 100);

//出力モード
define('OUTPUT_MODE', 'html');

/********* メイン処理 ***********************************************/

//最終実行時間を調べる
$flag = false;

if ($fp = fopen(LOG_FILE, 'r')) {
	$datetime = chop(fgets($fp));

	if (strtotime($datetime) + REQUEST_INTERVAL < time()) {
		$flag = true;
	}

	fclose($fp);
}

$result = '';

if ($flag) {
	//リクエスト送信
	$urls = explode(',', REQUEST_URL);

	foreach ($urls as $url) {
		$contents = file_get_contents($url);

		$result .= $url . '=' . $contents . '<br />';
	}

	//最終実行時間を記録
	if ($fp = fopen(LOG_FILE, 'r+')) {
		flock($fp, LOCK_EX);

		$data  = '';
		$count = 1;
		while ($line = fgets($fp)) {
			if ($count++ >= LOG_LIMIT) {
				break;
			}

			$data .= $line;
		}

		rewind($fp);
		fwrite($fp, date('Y-m-d H:i:s') . "\n" . $data);
		ftruncate($fp, ftell($fp));

		fclose($fp);
	}
}

if (OUTPUT_MODE == 'html') {
	//HTML出力
	echo "<!DOCTYPE html>\n";
	echo "<html lang=\"ja\">\n";
	echo "<head>\n";
	echo "<meta charset=\"utf-8\" />\n";
	echo "<title>cron_like</title>\n";
	echo "</head>\n";
	echo "<body>\n";
	echo "<h1>cron_like</h1>\n";
	echo $result . "\n";
	echo "</body>\n";
	echo "</html>\n";
} else {
	//ダミー画像出力
	$dammy = array(
		'47','49','46','38','39','61','01','00','01','00','80','00','00','00',
		'00','00','FF','FF','FF','21','F9','04','01','00','00','01','00','2C',
		'00','00','00','00','01','00','01','00','00','02','01','4C','00','3B'
	);

	header('Pragma: no-cache');
	header('Cache-control: no-cache');
	header('Expires: Thu, 01 Dec 1994 16:00:00 GMT');
	header('Content-type: image/gif');

	foreach ($dammy as $data) {
		echo pack('C*', hexdec($data));
	}
}

exit;

?>
